include asm.e

--*** read-'n-write variables for asm code ***--
global constant asm_fireAddr=allocate(4)
global constant asm_fireAddr2=allocate(4)

--*** code for drawing the fire. The Euphoria equivalent is at the bottom of- ***--
--*** this file (just to make things clearer).                                ***--
global constant fireCode=get_asm(
"pusha cld "&			--*** push all registers and clear direction flag ***--
"mov dl,2 "&			--*** drawing starts at y=2 ***--
"yloop: "&
"mov esi,[asm_fireAddr] "&	--*** esi=(vscreen+(y*320)+x-2) ***--
"xor eax,eax "&			--*** set eax to zero ***--
"lodsb "&
"mov ebx,eax "&
"inc esi "&			--*** esi=(vscreen+(y*320)+x) ***--		    	
"lodsb "&
"add ebx,eax "&
"inc esi "&			--*** esi=(vscreen+(y*320)+x+2) ***--			
"lodsb "&
"add ebx,eax "&
"add esi,639 "&			--*** esi=(vscreen+((y+2)*320)+x+2) ***--
"lodsb "&
"add ebx,eax "&
"shr ebx,2 "&			--*** col=floor(col/4) ***--
"cmp ebx,0 "&			--*** is col=0 ? ***--
"je noDec "&			--*** yep, jump to noDec ***--
"dec ebx "&			--*** nope, decrease col by 1 ***--
"noDec: "&
"mov eax,ebx "&		
"shl eax,8 "&			--*** comment this line and the next one for a cool effect ***--
"add eax,ebx "&			--*** eax=(col*256)+col ***--
"mov edi,[asm_fireAddr2] "&	--*** edi=(vscreen+((y-2)*320)+x) ***--
"stosw "&			--*** poke(edi,{al,ah})  edi=edi+2 ***--
"add edi,318 "&			--*** edi=(vscreen+((y-1)*320)+x) ***--
"stosw "&			--*** poke(edi,{al,ah})  edi=edi+2***--
"mov eax,[asm_fireAddr] "&	
"add eax,320 "&			--*** increase address by 320 ***--
"mov [asm_fireAddr],eax "&
"mov eax,[asm_fireAddr2] "&
"add eax,320 "&			--*** increase this one too ***--
"mov [asm_fireAddr2],eax "&
"add dl,1 "&			--*** y=y+1 ***--
"cmp dl,202 "&			--*** done yet ? ***--
"jbe yloop "&			--*** nah, draw some more ***--
"popa ret")			--*** pop all registers and return ***--
resolve_param("asm_fireAddr", fireCode, asm_fireAddr)
resolve_param("asm_fireAddr2", fireCode, asm_fireAddr2)






--*** This would do the same thing as the above assembly code, but MUCH slower ***--
-- while (y<=202) do
--  col=floor((peek(vscreen+(y*320)+x)+peek(vscreen+(y*320)+x+2)+
--           peek(vscreen+(y*320)+x-2)+peek(vscreen+((y+2)*320)+x+2))/4)
--  if col!=0 then
--   col=col-1
--  end if
--  col=(256*col)+col
--  loCol=and_bits(col,#FF)
--  hiCol=(col-loCol)/256
--  poke(vscreen+((y-2)*320)+x,{loCol,hiCol})
--  poke(vscreen+((y-1)*320)+x,{loCol,hiCol})
--  y=y+1
-- end while